Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.tomcat.util.http.fileupload
Class FileCleaningTracker

    java.lang.Object
      org.apache.tomcat.util.http.fileupload.FileCleaningTracker

    public class FileCleaningTracker

extends Object

Keeps track of files awaiting deletion, and deletes them when an associated marker object is reclaimed by the garbage collector.

This utility creates a background thread to handle file deletion. Each file to be deleted is registered with a handler object. When the handler object is garbage collected, the file is deleted.

In an environment with multiple class loaders (a servlet container, for example), you should consider stopping the background thread if it is no longer needed. This is done by invoking the method `exitWhenFinished`, typically in `ServletContextListener.contextDestroyed(javax.servlet.ServletContextEvent)` or similar.

Version:
  $Id: FileCleaner.java 490987 2006-12-29 12:11:48Z scolebourne $
Author:
  Noel Bergman, Martin Cooper

Constructor Summary
`FileCleaningTracker()`

Method Summary
`void` | `exitWhenFinished()` Call this method to cause the file cleaner thread to terminate when there are no more objects being tracked for deletion.
`int` | `getTrackCount()` Retrieve the number of files currently being tracked, and therefore awaiting deletion.
`void` | `track(File file, Object marker)` Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected.
`void` | `track(File file, Object marker, FileDeleteStrategy deleteStrategy)` Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected.
`void` | `track(String path, Object marker)` Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected.
`void` | `track(String path, Object marker, FileDeleteStrategy deleteStrategy)` Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FileCleaningTracker

    public FileCleaningTracker()

Method Detail

### track

    public void track(File file,
                      Object marker)

  Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The `normal` deletion strategy will be used.

  Parameters:
    `file` - the file to be tracked, not null
    `marker` - the marker object used to track the file, not null
  Throws:
    `NullPointerException` - if the file is null

### track

    public void track(File file,
                      Object marker,
                      FileDeleteStrategy deleteStrategy)

  Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The speified deletion strategy is used.

  Parameters:
    `file` - the file to be tracked, not null
    `marker` - the marker object used to track the file, not null
    `deleteStrategy` - the strategy to delete the file, null means normal
  Throws:
    `NullPointerException` - if the file is null

### track

    public void track(String path,
                      Object marker)

  Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The `normal` deletion strategy will be used.

  Parameters:
    `path` - the full path to the file to be tracked, not null
    `marker` - the marker object used to track the file, not null
  Throws:
    `NullPointerException` - if the path is null

### track

    public void track(String path,
                      Object marker,
                      FileDeleteStrategy deleteStrategy)

  Track the specified file, using the provided marker, deleting the file when the marker instance is garbage collected. The speified deletion strategy is used.

  Parameters:
    `path` - the full path to the file to be tracked, not null
    `marker` - the marker object used to track the file, not null
    `deleteStrategy` - the strategy to delete the file, null means normal
  Throws:
    `NullPointerException` - if the path is null

### getTrackCount

    public int getTrackCount()

  Retrieve the number of files currently being tracked, and therefore awaiting deletion.

  Returns:
    the number of files being tracked

### exitWhenFinished

    public void exitWhenFinished()

  Call this method to cause the file cleaner thread to terminate when there are no more objects being tracked for deletion.

  In a simple environment, you don't need this method as the file cleaner thread will simply exit when the JVM exits. In a more complex environment, with multiple class loaders (such as an application server), you should be aware that the file cleaner thread will continue running even if the class loader it was started from terminates. This can consitute a memory leak.

  For example, suppose that you have developed a web application, which contains the commons-io jar file in your WEB-INF/lib directory. In other words, the FileCleaner class is loaded through the class loader of your web application. If the web application is terminated, but the servlet container is still running, then the file cleaner thread will still exist, posing a memory leak.

  This method allows the thread to be terminated. Simply call this method in the resource cleanup code, such as `ServletContextListener.contextDestroyed(javax.servlet.ServletContextEvent)`. One called, no new objects can be tracked by the file cleaner.

Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2012 Apache Software Foundation. All Rights Reserved.